diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StateDataSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StateDataSection.java
index c81f69bf3..07ea14414 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StateDataSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StateDataSection.java
@@ -12,8 +12,6 @@ package eu.etaxonomy.taxeditor.ui.section.description;
 
 import java.util.Collection;
 
-import org.apache.log4j.Logger;
-
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.description.CategoricalData;
 import eu.etaxonomy.cdm.model.description.StateData;
@@ -30,10 +28,6 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection;
  */
 public class StateDataSection extends AbstractEntityCollectionSection<CategoricalData, StateData> {
 
-
-	private static final Logger logger = Logger
-			.getLogger(StateDataSection.class);
-
 	/**
 	 * <p>Constructor for StateDataSection.</p>
 	 *
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StatisticalMeasurementValueElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StatisticalMeasurementValueElement.java
index 64b4c286a..bddaddeeb 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StatisticalMeasurementValueElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StatisticalMeasurementValueElement.java
@@ -19,6 +19,7 @@ import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.element.NumberWithLabelElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
@@ -67,7 +68,7 @@ public class StatisticalMeasurementValueElement extends
 		number_value = formFactory.createFloatTextWithLabelElement(element, "Value", 0, style);
 		combo_type = formFactory.createTermComboElement(StatisticalMeasure.class, element, "Statistical Measure", null, style);
 		section_modifiers = (ModifierSection) formFactory.createEntityDetailSection(EntityDetailType.MODIFIER, getConversationHolder(), element, Section.TWISTIE);
-		section_modifiers.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_modifiers.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 	}
 
 	/** {@inheritDoc} */
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StatisticalMeasurementValueSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StatisticalMeasurementValueSection.java
index 0c8291798..81fef0b58 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StatisticalMeasurementValueSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StatisticalMeasurementValueSection.java
@@ -12,8 +12,6 @@ package eu.etaxonomy.taxeditor.ui.section.description;
 
 import java.util.Collection;
 
-import org.apache.log4j.Logger;
-
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.description.QuantitativeData;
 import eu.etaxonomy.cdm.model.description.StatisticalMeasurementValue;
@@ -31,10 +29,6 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection;
 public class StatisticalMeasurementValueSection extends
 		AbstractEntityCollectionSection<QuantitativeData, StatisticalMeasurementValue> {
 	
-
-	private static final Logger logger = Logger
-			.getLogger(StatisticalMeasurementValueSection.class);
-
 	/**
 	 * <p>Constructor for StatisticalMeasurementValueSection.</p>
 	 *
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/AbstractDetailedDescriptionDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/AbstractDetailedDescriptionDetailElement.java
index 067d8a78a..85c1461bb 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/AbstractDetailedDescriptionDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/AbstractDetailedDescriptionDetailElement.java
@@ -10,8 +10,6 @@
 
 package eu.etaxonomy.taxeditor.ui.section.description.detail;
 
-import org.apache.log4j.Logger;
-
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
@@ -25,9 +23,6 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
  * @version 1.0
  */
 public abstract class AbstractDetailedDescriptionDetailElement<T extends DescriptionElementBase> extends AbstractCdmDetailElement<T>{
-
-	private static final Logger logger = Logger
-			.getLogger(AbstractDetailedDescriptionDetailElement.class);
 	
 	/**
 	 * <p>Constructor for AbstractDetailedDescriptionDetailElement.</p>
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/CategoricalDataDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/CategoricalDataDetailElement.java
index c5218d95e..8a65b46b5 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/CategoricalDataDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/CategoricalDataDetailElement.java
@@ -10,6 +10,7 @@ import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.CheckboxElement;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.section.description.StateDataSection;
 
 /**
@@ -43,7 +44,7 @@ public class CategoricalDataDetailElement extends AbstractDetailedDescriptionDet
 		checkbox_orderRelevant = formFactory.createCheckbox(formElement, "Order Relevant", entity.getOrderRelevant(), style);
 		section_stateData = (StateDataSection) formFactory.createEntityDetailSection(EntityDetailType.STATE_DATA, getConversationHolder(), formElement, Section.TWISTIE | Section.EXPANDED);
 		section_stateData.setEntity(entity);
-		section_stateData.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_stateData.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 	}
 	
 	/** {@inheritDoc} */
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/CommonNameDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/CommonNameDetailElement.java
index 2a5fcc75c..64e95d95b 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/CommonNameDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/CommonNameDetailElement.java
@@ -14,11 +14,12 @@ import org.eclipse.swt.SWT;
 
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.description.CommonTaxonName;
+import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.selection.NamedAreaSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>CommonNameDetailElement class.</p>
@@ -30,7 +31,7 @@ import eu.etaxonomy.taxeditor.ui.selection.NamedAreaSelectionElement;
 public class CommonNameDetailElement extends AbstractDetailedDescriptionDetailElement<CommonTaxonName> {
 	
 	private TermComboElement<Language> combo_language;
-	private NamedAreaSelectionElement selection_namedArea;
+	private EntitySelectionElement<NamedArea> selection_namedArea;
 	private TextWithLabelElement commonName;
 
 	
@@ -53,8 +54,9 @@ public class CommonNameDetailElement extends AbstractDetailedDescriptionDetailEl
 			CommonTaxonName entity, int style) {
 		combo_language = formFactory.createTermComboElement(Language.class, this, "Language", entity.getLanguage(), style);
 
-		selection_namedArea = formFactory.createNamedAreaSelectionElement(this, getConversationHolder(), "Area", entity.getArea(), style);
-		
+		selection_namedArea = formFactory.createSelectionElement(NamedArea.class, getConversationHolder(),
+				formElement, "Area",
+				entity.getArea(), EntitySelectionElement.NOTHING, style);
 		commonName = formFactory.createTextWithLabelElement(this, "Common Name", entity.getName(), SWT.WRAP);
 	}
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/DistributionDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/DistributionDetailElement.java
index 4ec618be2..a4cb75343 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/DistributionDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/DistributionDetailElement.java
@@ -12,10 +12,11 @@ package eu.etaxonomy.taxeditor.ui.section.description.detail;
 
 import eu.etaxonomy.cdm.model.description.Distribution;
 import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
+import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.selection.NamedAreaSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>DistributionDetailElement class.</p>
@@ -27,7 +28,7 @@ import eu.etaxonomy.taxeditor.ui.selection.NamedAreaSelectionElement;
 public class DistributionDetailElement extends
 		AbstractDetailedDescriptionDetailElement<Distribution> {
 
-	private NamedAreaSelectionElement selection_namedArea;
+	private EntitySelectionElement<NamedArea> selection_namedArea;
 	private TermComboElement<PresenceAbsenceTermBase> combo_presenceAbsence;
 	
 
@@ -48,8 +49,9 @@ public class DistributionDetailElement extends
 	@Override
 	protected void createControls(ICdmFormElement formElement,
 			Distribution entity, int style) {
-		selection_namedArea = formFactory.createNamedAreaSelectionElement(this, getConversationHolder(), "Area", entity.getArea(), style);
-		
+		selection_namedArea = formFactory.createSelectionElement(NamedArea.class, getConversationHolder(),
+				formElement, "Area",
+				entity.getArea(), EntitySelectionElement.NOTHING, style);
         combo_presenceAbsence = formFactory.createTermComboElement(PresenceAbsenceTermBase.class, this, "Distribution Status", entity.getStatus(), style);
         
 	}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/IndividualsAssociationDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/IndividualsAssociationDetailElement.java
index d5f9a8672..990ca4c5e 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/IndividualsAssociationDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/IndividualsAssociationDetailElement.java
@@ -12,17 +12,15 @@ package eu.etaxonomy.taxeditor.ui.section.description.detail;
 
 import java.util.Map;
 
-import org.apache.log4j.Logger;
-
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.common.LanguageString;
 import eu.etaxonomy.cdm.model.description.IndividualsAssociation;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
 import eu.etaxonomy.taxeditor.store.CdmStore;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
-import eu.etaxonomy.taxeditor.ui.selection.DerivedUnitBaseSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -36,10 +34,8 @@ import eu.etaxonomy.taxeditor.ui.selection.DerivedUnitBaseSelectionElement;
 public class IndividualsAssociationDetailElement extends
 		AbstractDetailedDescriptionDetailElement<IndividualsAssociation> {
 
-	private static final Logger logger = Logger
-			.getLogger(IndividualsAssociationDetailElement.class);
 	private TextWithLabelElement text_description;
-	private DerivedUnitBaseSelectionElement selection_derivedUnit;
+	private EntitySelectionElement<DerivedUnitBase> selection_derivedUnit;
 
 	/**
 	 * <p>
@@ -69,11 +65,11 @@ public class IndividualsAssociationDetailElement extends
 	@Override
 	protected void createControls(ICdmFormElement formElement,
 			IndividualsAssociation entity, int style) {
-		selection_derivedUnit = (DerivedUnitBaseSelectionElement) formFactory
-				.createSelectionElement(SelectionType.DERIVED_UNIT,
+		selection_derivedUnit = formFactory
+				.createSelectionElement(DerivedUnitBase.class,
 						getConversationHolder(), formElement, "Unit",
-						entity.getAssociatedSpecimenOrObservation(),
-						DerivedUnitBaseSelectionElement.DEFAULT, style);
+						(DerivedUnitBase) entity.getAssociatedSpecimenOrObservation(),
+						EntitySelectionElement.ALL, style);
 
 		text_description = formFactory.createMultilineTextWithLabel(
 				formElement, "Description", 200, style);
@@ -92,8 +88,7 @@ public class IndividualsAssociationDetailElement extends
 			getEntity().setAssociatedSpecimenOrObservation(
 					selection_derivedUnit.getEntity());
 		} else if (eventSource == text_description) {
-			getEntity().addDescription(text_description.getText(),
-					CdmStore.getDefaultLanguage());
+			getEntity().putDescription(CdmStore.getDefaultLanguage(), text_description.getText());
 		}
 
 	}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/QuantitativeDataDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/QuantitativeDataDetailElement.java
index db5856f95..11cbe80cf 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/QuantitativeDataDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/QuantitativeDataDetailElement.java
@@ -11,6 +11,7 @@ import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.section.description.StatisticalMeasurementValueSection;
 
 /**
@@ -45,7 +46,7 @@ public class QuantitativeDataDetailElement extends
 		combo_mesaurementUnit = formFactory.createTermComboElement(MeasurementUnit.class, formElement, "Measurement Unit", entity.getUnit(), style);
 		section_statisticalMeasurementValues = (StatisticalMeasurementValueSection) formFactory.createEntityDetailSection(EntityDetailType.STATISTICAL_MEASUREMENT_VALUE, getConversationHolder(), formElement, Section.TWISTIE | Section.EXPANDED);
 		section_statisticalMeasurementValues.setEntity(entity);
-		section_statisticalMeasurementValues.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_statisticalMeasurementValues.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 	}
 	
 	/* (non-Javadoc)
@@ -54,7 +55,11 @@ public class QuantitativeDataDetailElement extends
 	/** {@inheritDoc} */
 	@Override
 	public void handleEvent(Object eventSource) {
-		
+		if(eventSource == combo_mesaurementUnit){
+			getEntity().setUnit(combo_mesaurementUnit.getSelection());
+		}else if (eventSource == section_statisticalMeasurementValues){
+			// FIXME
+		}
 	}
 
 }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/TaxonInteractionDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/TaxonInteractionDetailElement.java
index 637a19c9b..bc6a2240f 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/TaxonInteractionDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/detail/TaxonInteractionDetailElement.java
@@ -13,12 +13,12 @@ package eu.etaxonomy.taxeditor.ui.section.description.detail;
 import org.eclipse.swt.SWT;
 
 import eu.etaxonomy.cdm.model.description.TaxonInteraction;
+import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.taxeditor.store.CdmStore;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
-import eu.etaxonomy.taxeditor.ui.selection.TaxonSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -32,7 +32,7 @@ import eu.etaxonomy.taxeditor.ui.selection.TaxonSelectionElement;
 public class TaxonInteractionDetailElement extends
 		AbstractDetailedDescriptionDetailElement<TaxonInteraction> {
 
-	private TaxonSelectionElement taxonSelection;
+	private EntitySelectionElement<Taxon> taxonSelection;
 	private TextWithLabelElement interactionDescription;
 
 	/**
@@ -61,10 +61,10 @@ public class TaxonInteractionDetailElement extends
 	@Override
 	protected void createControls(ICdmFormElement formElement,
 			TaxonInteraction entity, int style) {
-		taxonSelection = (TaxonSelectionElement) formFactory
-				.createSelectionElement(SelectionType.TAXON,
+		taxonSelection = formFactory
+				.createSelectionElement(Taxon.class,
 						getConversationHolder(), this, null,
-						entity.getTaxon2(), TaxonSelectionElement.DEFAULT,
+						entity.getTaxon2(), EntitySelectionElement.NOTHING,
 						SWT.WRAP);
 
 		interactionDescription = formFactory.createMultilineTextWithLabel(this,
@@ -79,8 +79,7 @@ public class TaxonInteractionDetailElement extends
 		if (eventSource == taxonSelection) {
 			getEntity().setTaxon2(taxonSelection.getEntity());
 		} else if (eventSource == interactionDescription) {
-			getEntity().addDescription(interactionDescription.getText(),
-					CdmStore.getDefaultLanguage());
+			getEntity().putDescription(CdmStore.getDefaultLanguage(), interactionDescription.getText());
 		}
 	}
 }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureDistributionDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureDistributionDetailElement.java
index 9b072f84c..522823664 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureDistributionDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureDistributionDetailElement.java
@@ -12,21 +12,15 @@ package eu.etaxonomy.taxeditor.ui.section.feature;
 
 import java.net.URI;
 import java.net.URISyntaxException;
-import java.util.ArrayList;
 import java.util.Arrays;
-import java.util.Collections;
-import java.util.HashSet;
 import java.util.List;
 import java.util.Map;
-import java.util.Set;
 
 import org.eclipse.swt.SWT;
 import org.eclipse.swt.widgets.Label;
 
 import eu.etaxonomy.cdm.common.UriUtils;
 import eu.etaxonomy.cdm.model.common.Language;
-import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
-import eu.etaxonomy.cdm.model.description.Distribution;
 import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.taxeditor.model.FeatureNodeContainer;
@@ -36,6 +30,7 @@ import eu.etaxonomy.taxeditor.store.CdmStore;
 import eu.etaxonomy.taxeditor.ui.element.BrowserElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 
 /**
@@ -88,7 +83,7 @@ public class FeatureDistributionDetailElement extends AbstractCdmDetailElement<F
 		
 		Label label = formFactory.createLabel(getLayoutComposite(), message, SWT.WRAP);
 		addControl(label);
-		label.setLayoutData(CdmFormFactory.FILL(2, 1));
+		label.setLayoutData(LayoutConstants.FILL(2, 1));
 	}
 
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/group/GrantedAuthorityDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/group/GrantedAuthorityDetailElement.java
index e661e8019..e614cd2ef 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/group/GrantedAuthorityDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/group/GrantedAuthorityDetailElement.java
@@ -11,7 +11,6 @@
 package eu.etaxonomy.taxeditor.ui.section.group;
 
 import org.eclipse.swt.events.SelectionListener;
-import org.eclipse.swt.graphics.Color;
 import org.springframework.security.core.GrantedAuthority;
 
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/group/MemberDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/group/MemberDetailElement.java
index d362b5901..1a828cb19 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/group/MemberDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/group/MemberDetailElement.java
@@ -16,9 +16,8 @@ import eu.etaxonomy.cdm.model.common.User;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.UserSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * @author n.hoffmann
@@ -27,7 +26,7 @@ import eu.etaxonomy.taxeditor.ui.selection.UserSelectionElement;
  */
 public class MemberDetailElement extends AbstractEntityCollectionElement<User> {
 
-	private UserSelectionElement selection_user;
+	private EntitySelectionElement<User> selection_user;
 
 	/**
 	 * @param formFactory
@@ -63,10 +62,10 @@ public class MemberDetailElement extends AbstractEntityCollectionElement<User> {
 	 */
 	@Override
 	public void createControls(ICdmFormElement element, int style) {
-		selection_user = (UserSelectionElement) formFactory
-				.createSelectionElement(SelectionType.USER,
+		selection_user = formFactory
+				.createSelectionElement(User.class,
 						getConversationHolder(), element, "Member", entity,
-						UserSelectionElement.EDITABLE, style);
+						EntitySelectionElement.EDITABLE, style);
 	}
 
 	/*
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/key/PolytomousKeyDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/key/PolytomousKeyDetailElement.java
index 763848b9c..90feceb60 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/key/PolytomousKeyDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/key/PolytomousKeyDetailElement.java
@@ -9,8 +9,6 @@ import eu.etaxonomy.cdm.model.description.PolytomousKey;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.CdmPropertyChangeEvent;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.element.ToggleableTextElement;
-import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractIdentifiableEntityDetailElement;
 
 /**
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/key/PolytomousKeyNodeDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/key/PolytomousKeyNodeDetailElement.java
index 57fe6dfbc..504563b01 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/key/PolytomousKeyNodeDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/key/PolytomousKeyNodeDetailElement.java
@@ -3,18 +3,16 @@
  */
 package eu.etaxonomy.taxeditor.ui.section.key;
 
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.description.PolytomousKey;
 import eu.etaxonomy.cdm.model.description.PolytomousKeyNode;
+import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.CdmPropertyChangeEvent;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.KeyStatementElement;
 import eu.etaxonomy.taxeditor.ui.element.NumberWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.FeatureSelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.PolytomousKeyNodeSelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.PolytomousKeySelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.TaxonSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * @author n.hoffmann
@@ -25,13 +23,13 @@ public class PolytomousKeyNodeDetailElement extends
 
 	private KeyStatementElement element_statement;
 
-	private FeatureSelectionElement selection_feature;
+	private EntitySelectionElement<Feature> selection_feature;
 
-	private TaxonSelectionElement selection_taxon;
+	private EntitySelectionElement<Taxon> selection_taxon;
 
-	private PolytomousKeySelectionElement selection_subkey;
+	private EntitySelectionElement<PolytomousKey> selection_subkey;
 
-	private PolytomousKeyNodeSelectionElement selection_otherNode;
+	private EntitySelectionElement<PolytomousKeyNode> selection_otherNode;
 
 	private KeyStatementElement element_question;
 
@@ -56,35 +54,35 @@ public class PolytomousKeyNodeDetailElement extends
 			element_question = formFactory.createKeyStatementElement(
 					formElement, "Question", parent.getQuestion(), 50, style);
 
-			selection_feature = (FeatureSelectionElement) formFactory
-					.createSelectionElement(SelectionType.FEATURE,
+			selection_feature = formFactory
+					.createSelectionElement(Feature.class,
 							getConversationHolder(), formElement, "Feature",
 							parent.getFeature(),
-							FeatureSelectionElement.DEFAULT, style);
+							EntitySelectionElement.EDITABLE | EntitySelectionElement.DELETABLE, style);
 		}
 
 		element_statement = formFactory.createKeyStatementElement(formElement,
 				"Statement", entity.getStatement(), 50, style);
 
 		if (entity.isLeaf()) {
-			selection_taxon = (TaxonSelectionElement) formFactory
-					.createSelectionElement(SelectionType.TAXON,
+			selection_taxon = formFactory
+					.createSelectionElement(Taxon.class,
 							getConversationHolder(), formElement, "Taxon",
-							entity.getTaxon(), TaxonSelectionElement.DELETABLE,
+							entity.getTaxon(), EntitySelectionElement.NOTHING,
 							style);
 		}
 
-		selection_subkey = (PolytomousKeySelectionElement) formFactory
-				.createSelectionElement(SelectionType.POLYTOMOUS_KEY,
+		selection_subkey = formFactory
+				.createSelectionElement(PolytomousKey.class,
 						getConversationHolder(), formElement, "Subkey",
 						entity.getSubkey(),
-						PolytomousKeySelectionElement.DEFAULT, style);
+						EntitySelectionElement.EDITABLE | EntitySelectionElement.DELETABLE, style);
 
-		selection_otherNode = (PolytomousKeyNodeSelectionElement) formFactory
-				.createSelectionElement(SelectionType.POLYTOMOUS_KEY_NODE,
+		selection_otherNode = formFactory
+				.createSelectionElement(PolytomousKeyNode.class,
 						getConversationHolder(), formElement, "Other Node",
 						entity.getOtherNode(),
-						PolytomousKeyNodeSelectionElement.DEFAULT, style);
+						EntitySelectionElement.DELETABLE, style);
 
 		formFactory.createMultiLanguageTextElement(formElement,
 				"Modifying Text", entity.getModifyingText(), 50, style);
